"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Create a scheme for an object.
 * The object is represented by an multi-dimensional array of property paths.
 */
function createScheme(source, path) {
    if (path === void 0) { path = []; }
    var scheme = [];
    Object.entries(source).forEach(function (_a) {
        var key = _a[0], value = _a[1];
        if (typeof value === 'function') {
            return;
        }
        else if (typeof value === 'object') {
            scheme.push.apply(scheme, createScheme(value, __spreadArray(__spreadArray([], path, true), [key], false)));
        }
        else {
            scheme.push(__spreadArray(__spreadArray([], path, true), [key], false));
        }
    });
    return scheme;
}
exports.default = createScheme;
