"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getDiff(mapA, mapB) {
    var additions = [], changes = [], deletions = [];
    mapA.forEach(function (value, key) {
        if (!mapB.has(key)) {
            deletions.push(key);
        }
        else if (value !== mapB.get(key)) {
            changes.push(key);
        }
        else {
            mapB.delete(key);
        }
    });
    mapB.forEach(function (value, key) {
        if (!mapA.has(key)) {
            additions.push(key);
        }
    });
    return {
        additions: additions,
        changes: changes,
        deletions: deletions
    };
}
exports.default = getDiff;
